<?php
/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Created on 19 sept. 07 by AEL Sarl for
 * 
 * osCommerce, Open Source E-Commerce Solutions
 * http://www.oscommerce.com
 *
 * Copyright (c) 2003 osCommerce
 *
 * Released under the GNU General Public License
 * 
 */

/**
 * Class for preparing an image to be uploaded
 */
class OpensiImage {

	public function __construct($image_name) {
		$this->image_path = DIR_FS_CATALOG . DIR_WS_IMAGES . $image_name;
		if (tep_not_null($image_name) && file_exists($this->image_path)) {
			$this->image_size = filesize($this->image_path);
		} else {
			$this->image_path = null;
			$this->image_size = 0;
		}
	}

	/**
	 * Prepare an image for upload, encoding it in base64 string
	 * @return	array	a report which content is:
	 *  					array[0] is image name
 	 *                      array[1] is image content as Base64 string
     *                     array[2] is image size
     *                  or returns null if the file cannot be found  
	 */	
	public function prepareUpload() {
		if ($this->image_path) {
			$fp = fopen($this->image_path, 'rb');
			$img = fread($fp, $this->image_size);
			fclose($fp);
		
			return array(substr(strrchr($this->image_path, "/"), 1),
		             	base64_encode($img),
		             	$this->image_size);
		} else
			return null;
	}
}	
?>
