<?php
/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Created on 9 oct. 07 by AEL Sarl for
 * 
 * osCommerce, Open Source E-Commerce Solutions
 * http://www.oscommerce.com
 *
 * Copyright (c) 2003 osCommerce
 *
 * Released under the GNU General Public License
 * 
 */
 
require_once("OpensiStructure.php");

class OpensiStructureVector implements OpensiStructure {
	
	/**
	 * Build an OpensiStructureVector
	 * 
	 * @param mixed	$struct	an array of OpensiStructure objects, or an OpensiStructure object
	 */
	public function __construct($struct=null) {
		$o_ = null;
		if ($struct ==  null)
			$o_ = array();
		else if (!is_array($struct) && ($struct instanceof OpensiStructure))
			$o_ = array($struct);
		else if (is_array($struct)) {
			foreach ($struct as $op) {
				if (!$op instanceof OpensiStructure) {
					$o_ = array();
					break;
				}
			}
			if (!is_array($o_))
				$o_ = $struct;
		} else
			$o_ = null;
			
		$this->structs = $o_;
	}
	
	/**
	 * Add an OpensiStructure object to the vector
	 * 
	 * @param	OpensiStructure	$struct	structure to add
	 */
	public function addStructure($struct) {
		if ($struct instanceof OpensiStructure)
			$this->structs[] = $struct;
	} 
	
	/**
	 * Get the number of elements in the vector
	 * 
	 * @return	int	number of element in the vector
	 */
	public function size() {
		return count($this->structs);
	}
	
	/**
	 * Prepare the upload of the vector object
	 * 
	 * @return array	prepared for upload object
	 */
	public function prepareUpload() {
		$prepared = array();
		foreach ($this->structs as $struct)
			$prepared[] = $struct->prepareUpload();
			
		return $prepared;	
	}
}
?>
